test-suite: Add `pass-if-equal'.
[bpt/guile.git] / maint.mk
CommitLineData
c84bdaf6
LC
1# -*-Makefile-*-
2# This Makefile fragment tries to be general-purpose enough to be
3# used by many projects via the gnulib maintainer-makefile module.
4
f0007cad 5## Copyright (C) 2001-2012 Free Software Foundation, Inc.
c84bdaf6
LC
6##
7## This program is free software: you can redistribute it and/or modify
8## it under the terms of the GNU General Public License as published by
9## the Free Software Foundation, either version 3 of the License, or
10## (at your option) any later version.
11##
12## This program is distributed in the hope that it will be useful,
13## but WITHOUT ANY WARRANTY; without even the implied warranty of
14## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15## GNU General Public License for more details.
16##
17## You should have received a copy of the GNU General Public License
18## along with this program. If not, see <http://www.gnu.org/licenses/>.
19
20# This is reported not to work with make-3.79.1
21# ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
22ME := maint.mk
23
7f1ea859
LC
24# Diagnostic for continued use of deprecated variable.
25# Remove in 2013
26ifneq ($(build_aux),)
27 $(error "$(ME): \
28set $$(_build-aux) relative to $$(srcdir) instead of $$(build_aux)")
29endif
c84bdaf6
LC
30
31# Do not save the original name or timestamp in the .tar.gz file.
32# Use --rsyncable if available.
33gzip_rsyncable := \
a927b6c1
LC
34 $(shell gzip --help 2>/dev/null|grep rsyncable >/dev/null \
35 && printf %s --rsyncable)
c84bdaf6
LC
36GZIP_ENV = '--no-name --best $(gzip_rsyncable)'
37
c84bdaf6
LC
38GIT = git
39VC = $(GIT)
c84bdaf6 40
7f1ea859 41VC_LIST = $(srcdir)/$(_build-aux)/vc-list-files -C $(srcdir)
c84bdaf6 42
61cd9dc9
LC
43# You can override this variable in cfg.mk to set your own regexp
44# matching files to ignore.
45VC_LIST_ALWAYS_EXCLUDE_REGEX ?= ^$$
46
47# This is to preprocess robustly the output of $(VC_LIST), so that even
48# when $(srcdir) is a pathological name like "....", the leading sed command
49# removes only the intended prefix.
50_dot_escaped_srcdir = $(subst .,\.,$(srcdir))
51
52# Post-process $(VC_LIST) output, prepending $(srcdir)/, but only
53# when $(srcdir) is not ".".
54ifeq ($(srcdir),.)
55_prepend_srcdir_prefix =
56else
57_prepend_srcdir_prefix = | sed 's|^|$(srcdir)/|'
58endif
59
60# In order to be able to consistently filter "."-relative names,
61# (i.e., with no $(srcdir) prefix), this definition is careful to
62# remove any $(srcdir) prefix, and to restore what it removes.
dd7d0148
LC
63_sc_excl = \
64 $(if $(exclude_file_name_regexp--$@),$(exclude_file_name_regexp--$@),^$$)
c84bdaf6 65VC_LIST_EXCEPT = \
61cd9dc9
LC
66 $(VC_LIST) | sed 's|^$(_dot_escaped_srcdir)/||' \
67 | if test -f $(srcdir)/.x-$@; then grep -vEf $(srcdir)/.x-$@; \
68 else grep -Ev -e "$${VC_LIST_EXCEPT_DEFAULT-ChangeLog}"; fi \
dd7d0148 69 | grep -Ev -e '($(VC_LIST_ALWAYS_EXCLUDE_REGEX)|$(_sc_excl))' \
61cd9dc9 70 $(_prepend_srcdir_prefix)
c84bdaf6
LC
71
72ifeq ($(origin prev_version_file), undefined)
73 prev_version_file = $(srcdir)/.prev-version
74endif
75
76PREV_VERSION := $(shell cat $(prev_version_file) 2>/dev/null)
77VERSION_REGEXP = $(subst .,\.,$(VERSION))
78PREV_VERSION_REGEXP = $(subst .,\.,$(PREV_VERSION))
79
80ifeq ($(VC),$(GIT))
81this-vc-tag = v$(VERSION)
82this-vc-tag-regexp = v$(VERSION_REGEXP)
83else
84tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
85tag-this-version = $(subst .,_,$(VERSION))
86this-vc-tag = $(tag-package)-$(tag-this-version)
87this-vc-tag-regexp = $(this-vc-tag)
88endif
89my_distdir = $(PACKAGE)-$(VERSION)
90
91# Old releases are stored here.
92release_archive_dir ?= ../release
93
414e4441
LC
94# Override gnu_rel_host and url_dir_list in cfg.mk if these are not right.
95# Use alpha.gnu.org for alpha and beta releases.
96# Use ftp.gnu.org for stable releases.
97gnu_ftp_host-alpha = alpha.gnu.org
98gnu_ftp_host-beta = alpha.gnu.org
99gnu_ftp_host-stable = ftp.gnu.org
100gnu_rel_host ?= $(gnu_ftp_host-$(RELEASE_TYPE))
101
102ifeq ($(gnu_rel_host),ftp.gnu.org)
103url_dir_list ?= http://ftpmirror.gnu.org/$(PACKAGE)
104else
105url_dir_list ?= ftp://$(gnu_rel_host)/gnu/$(PACKAGE)
106endif
107
1cd4fffc
LC
108# Override this in cfg.mk if you are using a different format in your
109# NEWS file.
110today = $(shell date +%Y-%m-%d)
9157d901
LC
111
112# Select which lines of NEWS are searched for $(news-check-regexp).
113# This is a sed line number spec. The default says that we search
114# lines 1..10 of NEWS for $(news-check-regexp).
115# If you want to search only line 3 or only lines 20-22, use "3" or "20,22".
116news-check-lines-spec ?= 1,10
1cd4fffc
LC
117news-check-regexp ?= '^\*.* $(VERSION_REGEXP) \($(today)\)'
118
c84bdaf6
LC
119# Prevent programs like 'sort' from considering distinct strings to be equal.
120# Doing it here saves us from having to set LC_ALL elsewhere in this file.
121export LC_ALL = C
122
123## --------------- ##
124## Sanity checks. ##
125## --------------- ##
126
127_cfg_mk := $(shell test -f $(srcdir)/cfg.mk && echo '$(srcdir)/cfg.mk')
128
f0007cad 129# Collect the names of rules starting with 'sc_'.
c84bdaf6
LC
130syntax-check-rules := $(sort $(shell sed -n 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' \
131 $(srcdir)/$(ME) $(_cfg_mk)))
132.PHONY: $(syntax-check-rules)
133
dd36ce77
MW
134ifeq ($(shell $(VC_LIST) >/dev/null 2>&1; echo $$?),0)
135local-checks-available += $(syntax-check-rules)
136else
137local-checks-available += no-vc-detected
138no-vc-detected:
139 @echo "No version control files detected; skipping syntax check"
140endif
c84bdaf6
LC
141.PHONY: $(local-checks-available)
142
143# Arrange to print the name of each syntax-checking rule just before running it.
144$(syntax-check-rules): %: %.m
dde9c5a4
LC
145sc_m_rules_ = $(patsubst %, %.m, $(syntax-check-rules))
146.PHONY: $(sc_m_rules_)
147$(sc_m_rules_):
c84bdaf6 148 @echo $(patsubst sc_%.m, %, $@)
a927b6c1
LC
149 @date +%s.%N > .sc-start-$(basename $@)
150
151# Compute and print the elapsed time for each syntax-check rule.
152sc_z_rules_ = $(patsubst %, %.z, $(syntax-check-rules))
153.PHONY: $(sc_z_rules_)
154$(sc_z_rules_): %.z: %
155 @end=$$(date +%s.%N); \
156 start=$$(cat .sc-start-$*); \
157 rm -f .sc-start-$*; \
158 awk -v s=$$start -v e=$$end \
159 'END {printf "%.2f $(patsubst sc_%,%,$*)\n", e - s}' < /dev/null
160
161# The patsubst here is to replace each sc_% rule with its sc_%.z wrapper
162# that computes and prints elapsed time.
163local-check := \
164 $(patsubst sc_%, sc_%.z, \
165 $(filter-out $(local-checks-to-skip), $(local-checks-available)))
c84bdaf6
LC
166
167syntax-check: $(local-check)
a927b6c1
LC
168
169# _sc_search_regexp
170#
171# This macro searches for a given construct in the selected files and
172# then takes some action.
173#
174# Parameters (shell variables):
175#
176# prohibit | require
177#
178# Regular expression (ERE) denoting either a forbidden construct
179# or a required construct. Those arguments are exclusive.
180#
005de2e8
LC
181# exclude
182#
183# Regular expression (ERE) denoting lines to ignore that matched
184# a prohibit construct. For example, this can be used to exclude
185# comments that mention why the nearby code uses an alternative
186# construct instead of the simpler prohibited construct.
187#
a927b6c1
LC
188# in_vc_files | in_files
189#
190# grep-E-style regexp denoting the files to check. If no files
191# are specified the default are all the files that are under
192# version control.
193#
194# containing | non_containing
195#
196# Select the files (non) containing strings matching this regexp.
197# If both arguments are specified then CONTAINING takes
198# precedence.
199#
200# with_grep_options
201#
202# Extra options for grep.
203#
204# ignore_case
205#
206# Ignore case.
207#
208# halt
209#
210# Message to display before to halting execution.
dd7d0148
LC
211#
212# Finally, you may exempt files based on an ERE matching file names.
213# For example, to exempt from the sc_space_tab check all files with the
214# .diff suffix, set this Make variable:
215#
216# exclude_file_name_regexp--sc_space_tab = \.diff$
217#
218# Note that while this functionality is mostly inherited via VC_LIST_EXCEPT,
219# when filtering by name via in_files, we explicitly filter out matching
220# names here as well.
a927b6c1 221
005de2e8
LC
222# Initialize each, so that envvar settings cannot interfere.
223export require =
224export prohibit =
225export exclude =
226export in_vc_files =
227export in_files =
228export containing =
229export non_containing =
230export halt =
231export with_grep_options =
232
a927b6c1 233# By default, _sc_search_regexp does not ignore case.
c84bdaf6 234export ignore_case =
a927b6c1 235_ignore_case = $$(test -n "$$ignore_case" && printf %s -i || :)
c84bdaf6 236
a927b6c1
LC
237define _sc_say_and_exit
238 dummy=; : so we do not need a semicolon before each use; \
239 { printf '%s\n' "$(ME): $$msg" 1>&2; exit 1; };
240endef
241
a927b6c1
LC
242define _sc_search_regexp
243 dummy=; : so we do not need a semicolon before each use; \
244 \
245 : Check arguments; \
246 test -n "$$prohibit" && test -n "$$require" \
247 && { msg='Cannot specify both prohibit and require' \
248 $(_sc_say_and_exit) } || :; \
249 test -z "$$prohibit" && test -z "$$require" \
250 && { msg='Should specify either prohibit or require' \
251 $(_sc_say_and_exit) } || :; \
005de2e8
LC
252 test -z "$$prohibit" && test -n "$$exclude" \
253 && { msg='Use of exclude requires a prohibit pattern' \
254 $(_sc_say_and_exit) } || :; \
a927b6c1
LC
255 test -n "$$in_vc_files" && test -n "$$in_files" \
256 && { msg='Cannot specify both in_vc_files and in_files' \
257 $(_sc_say_and_exit) } || :; \
258 test "x$$halt" != x \
259 || { msg='halt not defined' $(_sc_say_and_exit) }; \
260 \
261 : Filter by file name; \
262 if test -n "$$in_files"; then \
dd7d0148
LC
263 files=$$(find $(srcdir) | grep -E "$$in_files" \
264 | grep -Ev '$(exclude_file_name_regexp--$@)'); \
a927b6c1
LC
265 else \
266 files=$$($(VC_LIST_EXCEPT)); \
267 if test -n "$$in_vc_files"; then \
268 files=$$(echo "$$files" | grep -E "$$in_vc_files"); \
269 fi; \
270 fi; \
271 \
272 : Filter by content; \
273 test -n "$$files" && test -n "$$containing" \
274 && { files=$$(grep -l "$$containing" $$files); } || :; \
275 test -n "$$files" && test -n "$$non_containing" \
276 && { files=$$(grep -vl "$$non_containing" $$files); } || :; \
277 \
278 : Check for the construct; \
279 if test -n "$$files"; then \
280 if test -n "$$prohibit"; then \
281 grep $$with_grep_options $(_ignore_case) -nE "$$prohibit" $$files \
005de2e8 282 | grep -vE "$${exclude:-^$$}" \
a927b6c1
LC
283 && { msg="$$halt" $(_sc_say_and_exit) } || :; \
284 else \
285 grep $$with_grep_options $(_ignore_case) -LE "$$require" $$files \
286 | grep . \
287 && { msg="$$halt" $(_sc_say_and_exit) } || :; \
288 fi \
289 else :; \
290 fi || :;
c84bdaf6
LC
291endef
292
293sc_avoid_if_before_free:
7f1ea859 294 @$(srcdir)/$(_build-aux)/useless-if-before-free \
c84bdaf6
LC
295 $(useless_free_options) \
296 $$($(VC_LIST_EXCEPT) | grep -v useless-if-before-free) && \
297 { echo '$(ME): found useless "if" before "free" above' 1>&2; \
298 exit 1; } || :
299
300sc_cast_of_argument_to_free:
005de2e8 301 @prohibit='\<free *\( *\(' halt="don't cast free argument" \
a927b6c1 302 $(_sc_search_regexp)
c84bdaf6
LC
303
304sc_cast_of_x_alloc_return_value:
a927b6c1 305 @prohibit='\*\) *x(m|c|re)alloc\>' \
005de2e8 306 halt="don't cast x*alloc return value" \
a927b6c1 307 $(_sc_search_regexp)
c84bdaf6
LC
308
309sc_cast_of_alloca_return_value:
a927b6c1 310 @prohibit='\*\) *alloca\>' \
005de2e8 311 halt="don't cast alloca return value" \
a927b6c1 312 $(_sc_search_regexp)
c84bdaf6
LC
313
314sc_space_tab:
a927b6c1
LC
315 @prohibit='[ ] ' \
316 halt='found SPACE-TAB sequence; remove the SPACE' \
317 $(_sc_search_regexp)
c84bdaf6 318
f0007cad 319# Don't use *scanf or the old ato* functions in "real" code.
c84bdaf6
LC
320# They provide no error checking mechanism.
321# Instead, use strto* functions.
322sc_prohibit_atoi_atof:
a927b6c1
LC
323 @prohibit='\<([fs]?scanf|ato([filq]|ll)) *\(' \
324 halt='do not use *scan''f, ato''f, ato''i, ato''l, ato''ll or ato''q' \
325 $(_sc_search_regexp)
c84bdaf6
LC
326
327# Use STREQ rather than comparing strcmp == 0, or != 0.
005de2e8 328sp_ = strcmp *\(.+\)
c84bdaf6 329sc_prohibit_strcmp:
005de2e8
LC
330 @prohibit='! *strcmp *\(|\<$(sp_) *[!=]=|[!=]= *$(sp_)' \
331 exclude=':# *define STRN?EQ\(' \
332 halt='$(ME): replace strcmp calls above with STREQ/STRNEQ' \
333 $(_sc_search_regexp)
334
335# Really. You don't want to use this function.
336# It may fail to NUL-terminate the destination,
337# and always NUL-pads out to the specified length.
338sc_prohibit_strncpy:
339 @prohibit='\<strncpy *\(' \
340 halt='do not use strncpy, period' \
341 $(_sc_search_regexp)
c84bdaf6
LC
342
343# Pass EXIT_*, not number, to usage, exit, and error (when exiting)
414e4441
LC
344# Convert all uses automatically, via these two commands:
345# git grep -l '\<exit *(1)' \
346# | grep -vEf .x-sc_prohibit_magic_number_exit \
347# | xargs --no-run-if-empty \
348# perl -pi -e 's/(^|[^.])\b(exit ?)\(1\)/$1$2(EXIT_FAILURE)/'
349# git grep -l '\<exit *(0)' \
350# | grep -vEf .x-sc_prohibit_magic_number_exit \
351# | xargs --no-run-if-empty \
352# perl -pi -e 's/(^|[^.])\b(exit ?)\(0\)/$1$2(EXIT_SUCCESS)/'
c84bdaf6 353sc_prohibit_magic_number_exit:
a927b6c1
LC
354 @prohibit='(^|[^.])\<(usage|exit) ?\([0-9]|\<error ?\([1-9][0-9]*,' \
355 halt='use EXIT_* values rather than magic number' \
356 $(_sc_search_regexp)
c84bdaf6
LC
357
358# Using EXIT_SUCCESS as the first argument to error is misleading,
f0007cad 359# since when that parameter is 0, error does not exit. Use '0' instead.
c84bdaf6 360sc_error_exit_success:
a927b6c1
LC
361 @prohibit='error *\(EXIT_SUCCESS,' \
362 in_vc_files='\.[chly]$$' \
363 halt='found error (EXIT_SUCCESS' \
364 $(_sc_search_regexp)
c84bdaf6 365
f0007cad
LC
366# "FATAL:" should be fully upper-cased in error messages
367# "WARNING:" should be fully upper-cased, or fully lower-cased
c84bdaf6 368sc_error_message_warn_fatal:
a927b6c1 369 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
c84bdaf6
LC
370 | grep -E '"Warning|"Fatal|"fatal' && \
371 { echo '$(ME): use FATAL, WARNING or warning' 1>&2; \
372 exit 1; } || :
373
374# Error messages should not start with a capital letter
375sc_error_message_uppercase:
a927b6c1 376 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
c84bdaf6
LC
377 | grep -E '"[A-Z]' \
378 | grep -vE '"FATAL|"WARNING|"Java|"C#|PRIuMAX' && \
379 { echo '$(ME): found capitalized error message' 1>&2; \
380 exit 1; } || :
381
382# Error messages should not end with a period
383sc_error_message_period:
a927b6c1 384 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
c84bdaf6
LC
385 | grep -E '[^."]\."' && \
386 { echo '$(ME): found error message ending in period' 1>&2; \
387 exit 1; } || :
388
389sc_file_system:
a927b6c1
LC
390 @prohibit=file''system \
391 ignore_case=1 \
392 halt='found use of "file''system"; spell it "file system"' \
393 $(_sc_search_regexp)
c84bdaf6
LC
394
395# Don't use cpp tests of this symbol. All code assumes config.h is included.
396sc_prohibit_have_config_h:
a927b6c1
LC
397 @prohibit='^# *if.*HAVE''_CONFIG_H' \
398 halt='found use of HAVE''_CONFIG_H; remove' \
399 $(_sc_search_regexp)
c84bdaf6
LC
400
401# Nearly all .c files must include <config.h>. However, we also permit this
402# via inclusion of a package-specific header, if cfg.mk specified one.
403# config_h_header must be suitable for grep -E.
404config_h_header ?= <config\.h>
405sc_require_config_h:
a927b6c1
LC
406 @require='^# *include $(config_h_header)' \
407 in_vc_files='\.c$$' \
408 halt='the above files do not include <config.h>' \
409 $(_sc_search_regexp)
c84bdaf6
LC
410
411# You must include <config.h> before including any other header file.
412# This can possibly be via a package-specific header, if given by cfg.mk.
413sc_require_config_h_first:
414 @if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \
415 fail=0; \
416 for i in $$($(VC_LIST_EXCEPT) | grep '\.c$$'); do \
417 grep '^# *include\>' $$i | sed 1q \
418 | grep -E '^# *include $(config_h_header)' > /dev/null \
419 || { echo $$i; fail=1; }; \
420 done; \
421 test $$fail = 1 && \
422 { echo '$(ME): the above files include some other header' \
423 'before <config.h>' 1>&2; exit 1; } || :; \
424 else :; \
425 fi
426
427sc_prohibit_HAVE_MBRTOWC:
a927b6c1
LC
428 @prohibit='\bHAVE_MBRTOWC\b' \
429 halt="do not use $$prohibit; it is always defined" \
430 $(_sc_search_regexp)
c84bdaf6
LC
431
432# To use this "command" macro, you must first define two shell variables:
231c0e0e 433# h: the header name, with no enclosing <> or ""
c84bdaf6 434# re: a regular expression that matches IFF something provided by $h is used.
a927b6c1 435define _sc_header_without_use
c84bdaf6 436 dummy=; : so we do not need a semicolon before each use; \
231c0e0e 437 h_esc=`echo '[<"]'"$$h"'[">]'|sed 's/\./\\\\./g'`; \
c84bdaf6
LC
438 if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \
439 files=$$(grep -l '^# *include '"$$h_esc" \
440 $$($(VC_LIST_EXCEPT) | grep '\.c$$')) && \
441 grep -LE "$$re" $$files | grep . && \
442 { echo "$(ME): the above files include $$h but don't use it" \
443 1>&2; exit 1; } || :; \
444 else :; \
445 fi
446endef
447
448# Prohibit the inclusion of assert.h without an actual use of assert.
449sc_prohibit_assert_without_use:
231c0e0e 450 @h='assert.h' re='\<assert *\(' $(_sc_header_without_use)
c84bdaf6
LC
451
452# Prohibit the inclusion of close-stream.h without an actual use.
453sc_prohibit_close_stream_without_use:
231c0e0e 454 @h='close-stream.h' re='\<close_stream *\(' $(_sc_header_without_use)
c84bdaf6
LC
455
456# Prohibit the inclusion of getopt.h without an actual use.
457sc_prohibit_getopt_without_use:
231c0e0e 458 @h='getopt.h' re='\<getopt(_long)? *\(' $(_sc_header_without_use)
c84bdaf6
LC
459
460# Don't include quotearg.h unless you use one of its functions.
461sc_prohibit_quotearg_without_use:
231c0e0e 462 @h='quotearg.h' re='\<quotearg(_[^ ]+)? *\(' $(_sc_header_without_use)
c84bdaf6
LC
463
464# Don't include quote.h unless you use one of its functions.
465sc_prohibit_quote_without_use:
005de2e8
LC
466 @h='quote.h' re='\<quote((_n)? *\(|_quoting_options\>)' \
467 $(_sc_header_without_use)
c84bdaf6
LC
468
469# Don't include this header unless you use one of its functions.
470sc_prohibit_long_options_without_use:
231c0e0e 471 @h='long-options.h' re='\<parse_long_options *\(' \
a927b6c1 472 $(_sc_header_without_use)
c84bdaf6
LC
473
474# Don't include this header unless you use one of its functions.
475sc_prohibit_inttostr_without_use:
231c0e0e 476 @h='inttostr.h' re='\<(off|[iu]max|uint)tostr *\(' \
a927b6c1 477 $(_sc_header_without_use)
c84bdaf6 478
61cd9dc9
LC
479# Don't include this header unless you use one of its functions.
480sc_prohibit_ignore_value_without_use:
231c0e0e 481 @h='ignore-value.h' re='\<ignore_(value|ptr) *\(' \
a927b6c1 482 $(_sc_header_without_use)
61cd9dc9 483
c84bdaf6
LC
484# Don't include this header unless you use one of its functions.
485sc_prohibit_error_without_use:
231c0e0e 486 @h='error.h' \
c84bdaf6 487 re='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
a927b6c1 488 $(_sc_header_without_use)
c84bdaf6
LC
489
490# Don't include xalloc.h unless you use one of its functions.
491# Consider these symbols:
492# perl -lne '/^# *define (\w+)\(/ and print $1' lib/xalloc.h|grep -v '^__';
a927b6c1 493# perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/xalloc.h
c84bdaf6
LC
494# Divide into two sets on case, and filter each through this:
495# | sort | perl -MRegexp::Assemble -le \
496# 'print Regexp::Assemble->new(file => "/dev/stdin")->as_string'|sed 's/\?://g'
497# Note this was produced by the above:
61cd9dc9
LC
498# _xa1 = \
499#x(((2n?)?re|c(har)?|n(re|m)|z)alloc|alloc_(oversized|die)|m(alloc|emdup)|strdup)
500# But we can do better, in at least two ways:
501# 1) take advantage of two "dup"-suffixed strings:
502# x(((2n?)?re|c(har)?|n(re|m)|[mz])alloc|alloc_(oversized|die)|(mem|str)dup)
503# 2) notice that "c(har)?|[mz]" is equivalent to the shorter and more readable
504# "char|[cmz]"
505# x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
506_xa1 = x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
c84bdaf6
LC
507_xa2 = X([CZ]|N?M)ALLOC
508sc_prohibit_xalloc_without_use:
231c0e0e 509 @h='xalloc.h' \
c84bdaf6 510 re='\<($(_xa1)|$(_xa2)) *\('\
a927b6c1 511 $(_sc_header_without_use)
c84bdaf6 512
dde9c5a4 513# Extract function names:
a927b6c1 514# perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/hash.h
dde9c5a4
LC
515_hash_re = \
516clear|delete|free|get_(first|next)|insert|lookup|print_statistics|reset_tuning
517_hash_fn = \<($(_hash_re)) *\(
518_hash_struct = (struct )?\<[Hh]ash_(table|tuning)\>
519sc_prohibit_hash_without_use:
231c0e0e 520 @h='hash.h' \
dde9c5a4 521 re='$(_hash_fn)|$(_hash_struct)'\
a927b6c1 522 $(_sc_header_without_use)
dde9c5a4 523
3d458a81 524sc_prohibit_cloexec_without_use:
231c0e0e 525 @h='cloexec.h' re='\<(set_cloexec_flag|dup_cloexec) *\(' \
3d458a81
AW
526 $(_sc_header_without_use)
527
528sc_prohibit_posixver_without_use:
231c0e0e 529 @h='posixver.h' re='\<posix2_version *\(' $(_sc_header_without_use)
3d458a81
AW
530
531sc_prohibit_same_without_use:
231c0e0e 532 @h='same.h' re='\<same_name *\(' $(_sc_header_without_use)
3d458a81 533
dde9c5a4 534sc_prohibit_hash_pjw_without_use:
231c0e0e 535 @h='hash-pjw.h' \
005de2e8 536 re='\<hash_pjw\>' \
a927b6c1 537 $(_sc_header_without_use)
dde9c5a4 538
c84bdaf6 539sc_prohibit_safe_read_without_use:
231c0e0e 540 @h='safe-read.h' re='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
a927b6c1 541 $(_sc_header_without_use)
c84bdaf6
LC
542
543sc_prohibit_argmatch_without_use:
231c0e0e 544 @h='argmatch.h' \
35428fb6 545 re='(\<(ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<(invalid_arg|argmatch(_exit_fn|_(in)?valid)?) *\()' \
a927b6c1 546 $(_sc_header_without_use)
c84bdaf6
LC
547
548sc_prohibit_canonicalize_without_use:
231c0e0e 549 @h='canonicalize.h' \
005de2e8 550 re='CAN_(EXISTING|ALL_BUT_LAST|MISSING)|canonicalize_(mode_t|filename_mode|file_name)' \
a927b6c1 551 $(_sc_header_without_use)
c84bdaf6
LC
552
553sc_prohibit_root_dev_ino_without_use:
231c0e0e 554 @h='root-dev-ino.h' \
c84bdaf6 555 re='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
a927b6c1 556 $(_sc_header_without_use)
c84bdaf6
LC
557
558sc_prohibit_openat_without_use:
231c0e0e 559 @h='openat.h' \
c84bdaf6 560 re='\<(openat_(permissive|needs_fchdir|(save|restore)_fail)|l?(stat|ch(own|mod))at|(euid)?accessat)\>' \
a927b6c1 561 $(_sc_header_without_use)
c84bdaf6
LC
562
563# Prohibit the inclusion of c-ctype.h without an actual use.
564ctype_re = isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
565|isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper
566sc_prohibit_c_ctype_without_use:
231c0e0e 567 @h='c-ctype.h' re='\<c_($(ctype_re)) *\(' \
a927b6c1 568 $(_sc_header_without_use)
c84bdaf6
LC
569
570_empty =
571_sp = $(_empty) $(_empty)
572# The following list was generated by running:
573# man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and print' \
574# | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt
575_sig_functions = \
576 bsd_signal kill killpg pthread_kill pthread_sigmask raise sigaction \
577 sigaddset sigaltstack sigdelset sigemptyset sigfillset sighold sigignore \
578 siginterrupt sigismember signal sigpause sigpending sigprocmask sigqueue \
579 sigrelse sigset sigsuspend sigtimedwait sigwait sigwaitinfo
580_sig_function_re = $(subst $(_sp),|,$(strip $(_sig_functions)))
581# The following were extracted from "man signal.h" manually.
582_sig_types_and_consts = \
583 MINSIGSTKSZ SA_NOCLDSTOP SA_NOCLDWAIT SA_NODEFER SA_ONSTACK \
584 SA_RESETHAND SA_RESTART SA_SIGINFO SIGEV_NONE SIGEV_SIGNAL \
585 SIGEV_THREAD SIGSTKSZ SIG_BLOCK SIG_SETMASK SIG_UNBLOCK SS_DISABLE \
586 SS_ONSTACK mcontext_t pid_t sig_atomic_t sigevent siginfo_t sigset_t \
587 sigstack sigval stack_t ucontext_t
588# generated via this:
589# perl -lne '/^#ifdef (SIG\w+)/ and print $1' lib/sig2str.c|sort -u|fmt -70
590_sig_names = \
591 SIGABRT SIGALRM SIGALRM1 SIGBUS SIGCANCEL SIGCHLD SIGCLD SIGCONT \
592 SIGDANGER SIGDIL SIGEMT SIGFPE SIGFREEZE SIGGRANT SIGHUP SIGILL \
593 SIGINFO SIGINT SIGIO SIGIOT SIGKAP SIGKILL SIGKILLTHR SIGLOST SIGLWP \
594 SIGMIGRATE SIGMSG SIGPHONE SIGPIPE SIGPOLL SIGPRE SIGPROF SIGPWR \
595 SIGQUIT SIGRETRACT SIGSAK SIGSEGV SIGSOUND SIGSTKFLT SIGSTOP SIGSYS \
596 SIGTERM SIGTHAW SIGTRAP SIGTSTP SIGTTIN SIGTTOU SIGURG SIGUSR1 \
597 SIGUSR2 SIGVIRT SIGVTALRM SIGWAITING SIGWINCH SIGWIND SIGWINDOW \
598 SIGXCPU SIGXFSZ
599_sig_syms_re = $(subst $(_sp),|,$(strip $(_sig_names) $(_sig_types_and_consts)))
600
601# Prohibit the inclusion of signal.h without an actual use.
602sc_prohibit_signal_without_use:
231c0e0e 603 @h='signal.h' \
c84bdaf6 604 re='\<($(_sig_function_re)) *\(|\<($(_sig_syms_re))\>' \
a927b6c1
LC
605 $(_sc_header_without_use)
606
3d458a81
AW
607# Don't include stdio--.h unless you use one of its functions.
608sc_prohibit_stdio--_without_use:
231c0e0e 609 @h='stdio--.h' re='\<((f(re)?|p)open|tmpfile) *\(' \
3d458a81
AW
610 $(_sc_header_without_use)
611
612# Don't include stdio-safer.h unless you use one of its functions.
613sc_prohibit_stdio-safer_without_use:
231c0e0e 614 @h='stdio-safer.h' re='\<((f(re)?|p)open|tmpfile)_safer *\(' \
3d458a81
AW
615 $(_sc_header_without_use)
616
a927b6c1
LC
617# Prohibit the inclusion of strings.h without a sensible use.
618# Using the likes of bcmp, bcopy, bzero, index or rindex is not sensible.
619sc_prohibit_strings_without_use:
231c0e0e 620 @h='strings.h' \
a927b6c1
LC
621 re='\<(strn?casecmp|ffs(ll)?)\>' \
622 $(_sc_header_without_use)
623
624# Get the list of symbol names with this:
231c0e0e 625# perl -lne '/^# *define ([A-Z]\w+)\(/ and print $1' lib/intprops.h|fmt
a927b6c1
LC
626_intprops_names = \
627 TYPE_IS_INTEGER TYPE_TWOS_COMPLEMENT TYPE_ONES_COMPLEMENT \
628 TYPE_SIGNED_MAGNITUDE TYPE_SIGNED TYPE_MINIMUM TYPE_MAXIMUM \
231c0e0e
LC
629 INT_BITS_STRLEN_BOUND INT_STRLEN_BOUND INT_BUFSIZE_BOUND \
630 INT_ADD_RANGE_OVERFLOW INT_SUBTRACT_RANGE_OVERFLOW \
631 INT_NEGATE_RANGE_OVERFLOW INT_MULTIPLY_RANGE_OVERFLOW \
632 INT_DIVIDE_RANGE_OVERFLOW INT_REMAINDER_RANGE_OVERFLOW \
633 INT_LEFT_SHIFT_RANGE_OVERFLOW INT_ADD_OVERFLOW INT_SUBTRACT_OVERFLOW \
634 INT_NEGATE_OVERFLOW INT_MULTIPLY_OVERFLOW INT_DIVIDE_OVERFLOW \
635 INT_REMAINDER_OVERFLOW INT_LEFT_SHIFT_OVERFLOW
a927b6c1
LC
636_intprops_syms_re = $(subst $(_sp),|,$(strip $(_intprops_names)))
637# Prohibit the inclusion of intprops.h without an actual use.
638sc_prohibit_intprops_without_use:
231c0e0e 639 @h='intprops.h' \
a927b6c1
LC
640 re='\<($(_intprops_syms_re)) *\(' \
641 $(_sc_header_without_use)
c84bdaf6 642
49114fd4
LC
643_stddef_syms_re = NULL|offsetof|ptrdiff_t|size_t|wchar_t
644# Prohibit the inclusion of stddef.h without an actual use.
645sc_prohibit_stddef_without_use:
231c0e0e 646 @h='stddef.h' \
7f1ea859
LC
647 re='\<($(_stddef_syms_re))\>' \
648 $(_sc_header_without_use)
649
650_de1 = dirfd|(close|(fd)?open|read|rewind|seek|tell)dir(64)?(_r)?
651_de2 = (versionsort|struct dirent|getdirentries|alphasort|scandir(at)?)(64)?
652_de3 = MAXNAMLEN|DIR|ino_t|d_ino|d_fileno|d_namlen
653_dirent_syms_re = $(_de1)|$(_de2)|$(_de3)
654# Prohibit the inclusion of dirent.h without an actual use.
655sc_prohibit_dirent_without_use:
656 @h='dirent.h' \
657 re='\<($(_dirent_syms_re))\>' \
49114fd4
LC
658 $(_sc_header_without_use)
659
35428fb6
LC
660# Prohibit the inclusion of verify.h without an actual use.
661sc_prohibit_verify_without_use:
662 @h='verify.h' \
663 re='\<(verify(true|expr)?|static_assert) *\(' \
664 $(_sc_header_without_use)
665
3d458a81
AW
666# Don't include xfreopen.h unless you use one of its functions.
667sc_prohibit_xfreopen_without_use:
231c0e0e 668 @h='xfreopen.h' re='\<xfreopen *\(' $(_sc_header_without_use)
3d458a81 669
c84bdaf6 670sc_obsolete_symbols:
a927b6c1
LC
671 @prohibit='\<(HAVE''_FCNTL_H|O''_NDELAY)\>' \
672 halt='do not use HAVE''_FCNTL_H or O'_NDELAY \
673 $(_sc_search_regexp)
c84bdaf6
LC
674
675# FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
676
677# Each nonempty ChangeLog line must start with a year number, or a TAB.
678sc_changelog:
a927b6c1
LC
679 @prohibit='^[^12 ]' \
680 in_vc_files='^ChangeLog$$' \
681 halt='found unexpected prefix in a ChangeLog' \
682 $(_sc_search_regexp)
c84bdaf6
LC
683
684# Ensure that each .c file containing a "main" function also
685# calls set_program_name.
686sc_program_name:
a927b6c1
LC
687 @require='set_program_name *\(m?argv\[0\]\);' \
688 in_vc_files='\.c$$' \
0f00f2c3 689 containing='\<main *(' \
a927b6c1
LC
690 halt='the above files do not call set_program_name' \
691 $(_sc_search_regexp)
c84bdaf6 692
0f00f2c3
LC
693# Ensure that each .c file containing a "main" function also
694# calls bindtextdomain.
695sc_bindtextdomain:
696 @require='bindtextdomain *\(' \
697 in_vc_files='\.c$$' \
698 containing='\<main *(' \
699 halt='the above files do not call bindtextdomain' \
700 $(_sc_search_regexp)
701
c84bdaf6
LC
702# Require that the final line of each test-lib.sh-using test be this one:
703# Exit $fail
704# Note: this test requires GNU grep's --label= option.
705Exit_witness_file ?= tests/test-lib.sh
706Exit_base := $(notdir $(Exit_witness_file))
707sc_require_test_exit_idiom:
708 @if test -f $(srcdir)/$(Exit_witness_file); then \
709 die=0; \
710 for i in $$(grep -l -F 'srcdir/$(Exit_base)' \
711 $$($(VC_LIST) tests)); do \
712 tail -n1 $$i | grep '^Exit .' > /dev/null \
713 && : || { die=1; echo $$i; } \
714 done; \
715 test $$die = 1 && \
716 { echo 1>&2 '$(ME): the final line in each of the above is not:'; \
717 echo 1>&2 'Exit something'; \
718 exit 1; } || :; \
719 fi
720
c84bdaf6 721sc_trailing_blank:
a927b6c1
LC
722 @prohibit='[ ]$$' \
723 halt='found trailing blank(s)' \
724 $(_sc_search_regexp)
c84bdaf6
LC
725
726# Match lines like the following, but where there is only one space
727# between the options and the description:
728# -D, --all-repeated[=delimit-method] print all duplicate lines\n
729longopt_re = --[a-z][0-9A-Za-z-]*(\[?=[0-9A-Za-z-]*\]?)?
730sc_two_space_separator_in_usage:
a927b6c1
LC
731 @prohibit='^ *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$' \
732 halt='help2man requires at least two spaces between an option and its description'\
733 $(_sc_search_regexp)
c84bdaf6 734
3d458a81
AW
735# A regexp matching function names like "error" that may be used
736# to emit translatable messages.
737_gl_translatable_diag_func_re ?= error
738
c84bdaf6
LC
739# Look for diagnostics that aren't marked for translation.
740# This won't find any for which error's format string is on a separate line.
741sc_unmarked_diagnostics:
005de2e8
LC
742 @prohibit='\<$(_gl_translatable_diag_func_re) *\([^"]*"[^"]*[a-z]{3}' \
743 exclude='(_|ngettext ?)\(' \
744 halt='$(ME): found unmarked diagnostic(s)' \
745 $(_sc_search_regexp)
c84bdaf6
LC
746
747# Avoid useless parentheses like those in this example:
748# #if defined (SYMBOL) || defined (SYM2)
749sc_useless_cpp_parens:
a927b6c1
LC
750 @prohibit='^# *if .*defined *\(' \
751 halt='found useless parentheses in cpp directive' \
752 $(_sc_search_regexp)
753
754# List headers for which HAVE_HEADER_H is always true, assuming you are
755# using the appropriate gnulib module. CAUTION: for each "unnecessary"
756# #if HAVE_HEADER_H that you remove, be sure that your project explicitly
757# requires the gnulib module that guarantees the usability of that header.
758gl_assured_headers_ = \
759 cd $(gnulib_dir)/lib && echo *.in.h|sed 's/\.in\.h//g'
760
761# Convert the list of names to upper case, and replace each space with "|".
762az_ = abcdefghijklmnopqrstuvwxyz
763AZ_ = ABCDEFGHIJKLMNOPQRSTUVWXYZ
764gl_header_upper_case_or_ = \
765 $$($(gl_assured_headers_) \
766 | tr $(az_)/.- $(AZ_)___ \
767 | tr -s ' ' '|' \
768 )
769sc_prohibit_always_true_header_tests:
770 @or=$(gl_header_upper_case_or_); \
771 re="HAVE_($$or)_H"; \
772 prohibit='\<'"$$re"'\>' \
0f00f2c3
LC
773 halt=$$(printf '%s\n' \
774 'do not test the above HAVE_<header>_H symbol(s);' \
775 ' with the corresponding gnulib module, they are always true') \
a927b6c1
LC
776 $(_sc_search_regexp)
777
778# ==================================================================
779gl_other_headers_ ?= \
780 intprops.h \
781 openat.h \
782 stat-macros.h
783
784# Perl -lne code to extract "significant" cpp-defined symbols from a
785# gnulib header file, eliminating a few common false-positives.
7f1ea859
LC
786# The exempted names below are defined only conditionally in gnulib,
787# and hence sometimes must/may be defined in application code.
a927b6c1
LC
788gl_extract_significant_defines_ = \
789 /^\# *define ([^_ (][^ (]*)(\s*\(|\s+\w+)/\
790 && $$2 !~ /(?:rpl_|_used_without_)/\
7f1ea859 791 && $$1 !~ /^(?:NSIG|ENODATA)$$/\
35428fb6 792 && $$1 !~ /^(?:SA_RESETHAND|SA_RESTART)$$/\
a927b6c1
LC
793 and print $$1
794
795# Create a list of regular expressions matching the names
796# of macros that are guaranteed to be defined by parts of gnulib.
797define def_sym_regex
798 gen_h=$(gl_generated_headers_); \
799 (cd $(gnulib_dir)/lib; \
800 for f in *.in.h $(gl_other_headers_); do \
35428fb6
LC
801 test -f $$f \
802 && perl -lne '$(gl_extract_significant_defines_)' $$f; \
a927b6c1
LC
803 done; \
804 ) | sort -u \
a927b6c1
LC
805 | sed 's/^/^ *# *(define|undef) */;s/$$/\\>/'
806endef
807
808# Don't define macros that we already get from gnulib header files.
809sc_prohibit_always-defined_macros:
810 @if test -d $(gnulib_dir); then \
811 case $$(echo all: | grep -l -f - Makefile) in Makefile);; *) \
812 echo '$(ME): skipping $@: you lack GNU grep' 1>&2; exit 0;; \
813 esac; \
814 $(def_sym_regex) | grep -E -f - $$($(VC_LIST_EXCEPT)) \
815 && { echo '$(ME): define the above via some gnulib .h file' \
816 1>&2; exit 1; } || :; \
817 fi
818# ==================================================================
819
820# Prohibit checked in backup files.
821sc_prohibit_backup_files:
822 @$(VC_LIST) | grep '~$$' && \
823 { echo '$(ME): found version controlled backup file' 1>&2; \
824 exit 1; } || :
c84bdaf6
LC
825
826# Require the latest GPL.
827sc_GPL_version:
a927b6c1
LC
828 @prohibit='either ''version [^3]' \
829 halt='GPL vN, N!=3' \
830 $(_sc_search_regexp)
c84bdaf6 831
61cd9dc9
LC
832# Require the latest GFDL. Two regexp, since some .texi files end up
833# line wrapping between 'Free Documentation License,' and 'Version'.
834_GFDL_regexp = (Free ''Documentation.*Version 1\.[^3]|Version 1\.[^3] or any)
835sc_GFDL_version:
a927b6c1
LC
836 @prohibit='$(_GFDL_regexp)' \
837 halt='GFDL vN, N!=3' \
838 $(_sc_search_regexp)
839
0f00f2c3
LC
840# Don't use Texinfo's @acronym{}.
841# http://lists.gnu.org/archive/html/bug-gnulib/2010-03/msg00321.html
a927b6c1
LC
842texinfo_suffix_re_ ?= \.(txi|texi(nfo)?)$$
843sc_texinfo_acronym:
844 @prohibit='@acronym\{' \
845 in_vc_files='$(texinfo_suffix_re_)' \
846 halt='found use of Texinfo @acronym{}' \
847 $(_sc_search_regexp)
61cd9dc9 848
c84bdaf6
LC
849cvs_keywords = \
850 Author|Date|Header|Id|Name|Locker|Log|RCSfile|Revision|Source|State
851
852sc_prohibit_cvs_keyword:
a927b6c1
LC
853 @prohibit='\$$($(cvs_keywords))\$$' \
854 halt='do not use CVS keyword expansion' \
855 $(_sc_search_regexp)
856
857# This Perl code is slightly obfuscated. Not only is each "$" doubled
858# because it's in a Makefile, but the $$c's are comments; we cannot
859# use "#" due to the way the script ends up concatenated onto one line.
860# It would be much more concise, and would produce better output (including
861# counts) if written as:
862# perl -ln -0777 -e '/\n(\n+)$/ and print "$ARGV: ".length $1' ...
863# but that would be far less efficient, reading the entire contents
864# of each file, rather than just the last two bytes of each.
dd36ce77
MW
865# In addition, while the code below detects both blank lines and a missing
866# newline at EOF, the above detects only the former.
a927b6c1
LC
867#
868# This is a perl script that is expected to be the single-quoted argument
869# to a command-line "-le". The remaining arguments are file names.
f0007cad 870# Print the name of each file that does not end in exactly one newline byte.
dd36ce77
MW
871# I.e., warn if there are blank lines (2 or more newlines), or if the
872# last byte is not a newline. However, currently we don't complain
873# about any file that contains exactly one byte.
a927b6c1
LC
874# Exit nonzero if at least one such file is found, otherwise, exit 0.
875# Warn about, but otherwise ignore open failure. Ignore seek/read failure.
876#
877# Use this if you want to remove trailing empty lines from selected files:
878# perl -pi -0777 -e 's/\n\n+$/\n/' files...
879#
dd36ce77 880require_exactly_one_NL_at_EOF_ = \
a927b6c1
LC
881 foreach my $$f (@ARGV) \
882 { \
883 open F, "<", $$f or (warn "failed to open $$f: $$!\n"), next; \
884 my $$p = sysseek (F, -2, 2); \
885 my $$c = "seek failure probably means file has < 2 bytes; ignore"; \
886 my $$last_two_bytes; \
887 defined $$p and $$p = sysread F, $$last_two_bytes, 2; \
888 close F; \
889 $$c = "ignore read failure"; \
dd36ce77
MW
890 $$p && ($$last_two_bytes eq "\n\n" \
891 || substr ($$last_two_bytes,1) ne "\n") \
892 and (print $$f), $$fail=1; \
a927b6c1
LC
893 } \
894 END { exit defined $$fail }
895sc_prohibit_empty_lines_at_EOF:
dd36ce77 896 @perl -le '$(require_exactly_one_NL_at_EOF_)' $$($(VC_LIST_EXCEPT)) \
dd7d0148
LC
897 || { echo '$(ME): empty line(s) or no newline at EOF' \
898 1>&2; exit 1; } || :
c84bdaf6
LC
899
900# Make sure we don't use st_blocks. Use ST_NBLOCKS instead.
901# This is a bit of a kludge, since it prevents use of the string
902# even in comments, but for now it does the job with no false positives.
903sc_prohibit_stat_st_blocks:
a927b6c1
LC
904 @prohibit='[.>]st_blocks' \
905 halt='do not use st_blocks; use ST_NBLOCKS' \
906 $(_sc_search_regexp)
c84bdaf6
LC
907
908# Make sure we don't define any S_IS* macros in src/*.c files.
909# They're already defined via gnulib's sys/stat.h replacement.
910sc_prohibit_S_IS_definition:
a927b6c1
LC
911 @prohibit='^ *# *define *S_IS' \
912 halt='do not define S_IS* macros; include <sys/stat.h>' \
913 $(_sc_search_regexp)
914
3d458a81
AW
915# Perl block to convert a match to FILE_NAME:LINENO:TEST,
916# that is shared by two definitions below.
917perl_filename_lineno_text_ = \
dd7d0148
LC
918 -e ' {' \
919 -e ' $$n = ($$` =~ tr/\n/\n/ + 1);' \
920 -e ' ($$v = $$&) =~ s/\n/\\n/g;' \
921 -e ' print "$$ARGV:$$n:$$v\n";' \
922 -e ' }'
923
3d458a81
AW
924prohibit_doubled_word_RE_ ?= \
925 /\b(then?|[iao]n|i[fst]|but|f?or|at|and|[dt]o)\s+\1\b/gims
926prohibit_doubled_word_ = \
927 -e 'while ($(prohibit_doubled_word_RE_))' \
928 $(perl_filename_lineno_text_)
929
dd7d0148
LC
930# Define this to a regular expression that matches
931# any filename:dd:match lines you want to ignore.
932# The default is to ignore no matches.
933ignore_doubled_word_match_RE_ ?= ^$$
934
935sc_prohibit_doubled_word:
936 @perl -n -0777 $(prohibit_doubled_word_) $$($(VC_LIST_EXCEPT)) \
937 | grep -vE '$(ignore_doubled_word_match_RE_)' \
938 | grep . && { echo '$(ME): doubled words' 1>&2; exit 1; } || :
939
3d458a81
AW
940# A regular expression matching undesirable combinations of words like
941# "can not"; this matches them even when the two words appear on different
942# lines, but not when there is an intervening delimiter like "#" or "*".
005de2e8
LC
943# Similarly undesirable, "See @xref{...}", since an @xref should start
944# a sentence. Explicitly prohibit any prefix of "see" or "also".
945# Also prohibit a prefix matching "\w+ +".
946# @pxref gets the same see/also treatment and should be parenthesized;
947# presume it must *not* start a sentence.
948bad_xref_re_ ?= (?:[\w,:;] +|(?:see|also)\s+)\@xref\{
949bad_pxref_re_ ?= (?:[.!?]|(?:see|also))\s+\@pxref\{
3d458a81 950prohibit_undesirable_word_seq_RE_ ?= \
005de2e8 951 /(?:\bcan\s+not\b|$(bad_xref_re_)|$(bad_pxref_re_))/gims
3d458a81
AW
952prohibit_undesirable_word_seq_ = \
953 -e 'while ($(prohibit_undesirable_word_seq_RE_))' \
954 $(perl_filename_lineno_text_)
955# Define this to a regular expression that matches
956# any filename:dd:match lines you want to ignore.
957# The default is to ignore no matches.
958ignore_undesirable_word_sequence_RE_ ?= ^$$
959
960sc_prohibit_undesirable_word_seq:
961 @perl -n -0777 $(prohibit_undesirable_word_seq_) \
962 $$($(VC_LIST_EXCEPT)) \
963 | grep -vE '$(ignore_undesirable_word_sequence_RE_)' | grep . \
964 && { echo '$(ME): undesirable word sequence' >&2; exit 1; } || :
dd7d0148 965
a927b6c1
LC
966_ptm1 = use "test C1 && test C2", not "test C1 -''a C2"
967_ptm2 = use "test C1 || test C2", not "test C1 -''o C2"
968# Using test's -a and -o operators is not portable.
969# We prefer test over [, since the latter is spelled [[ in configure.ac.
970sc_prohibit_test_minus_ao:
971 @prohibit='(\<test| \[+) .+ -[ao] ' \
972 halt='$(_ptm1); $(_ptm2)' \
973 $(_sc_search_regexp)
c84bdaf6 974
0f00f2c3
LC
975# Avoid a test bashism.
976sc_prohibit_test_double_equal:
977 @prohibit='(\<test| \[+) .+ == ' \
978 containing='#! */bin/[a-z]*sh' \
979 halt='use "test x = x", not "test x =''= x"' \
980 $(_sc_search_regexp)
981
61cd9dc9
LC
982# Each program that uses proper_name_utf8 must link with one of the
983# ICONV libraries. Otherwise, some ICONV library must appear in LDADD.
984# The perl -0777 invocation below extracts the possibly-multi-line
985# definition of LDADD from the appropriate Makefile.am and exits 0
986# when it contains "ICONV".
c84bdaf6
LC
987sc_proper_name_utf8_requires_ICONV:
988 @progs=$$(grep -l 'proper_name_utf8 ''("' $$($(VC_LIST_EXCEPT)));\
989 if test "x$$progs" != x; then \
990 fail=0; \
991 for p in $$progs; do \
992 dir=$$(dirname "$$p"); \
61cd9dc9
LC
993 perl -0777 \
994 -ne 'exit !(/^LDADD =(.+?[^\\]\n)/ms && $$1 =~ /ICONV/)' \
995 $$dir/Makefile.am && continue; \
c84bdaf6
LC
996 base=$$(basename "$$p" .c); \
997 grep "$${base}_LDADD.*ICONV)" $$dir/Makefile.am > /dev/null \
998 || { fail=1; echo 1>&2 "$(ME): $$p uses proper_name_utf8"; }; \
999 done; \
1000 test $$fail = 1 && \
1001 { echo 1>&2 '$(ME): the above do not link with any ICONV library'; \
1002 exit 1; } || :; \
1003 fi
1004
1005# Warn about "c0nst struct Foo const foo[]",
1006# but not about "char const *const foo" or "#define const const".
1007sc_redundant_const:
a927b6c1
LC
1008 @prohibit='\bconst\b[[:space:][:alnum:]]{2,}\bconst\b' \
1009 halt='redundant "const" in declarations' \
1010 $(_sc_search_regexp)
c84bdaf6
LC
1011
1012sc_const_long_option:
005de2e8
LC
1013 @prohibit='^ *static.*struct option ' \
1014 exclude='const struct option|struct option const' \
1015 halt='$(ME): add "const" to the above declarations' \
1016 $(_sc_search_regexp)
c84bdaf6
LC
1017
1018NEWS_hash = \
1019 $$(sed -n '/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p' \
1020 $(srcdir)/NEWS \
61cd9dc9
LC
1021 | perl -0777 -pe \
1022 's/^Copyright.+?Free\sSoftware\sFoundation,\sInc\.\n//ms' \
c84bdaf6
LC
1023 | md5sum - \
1024 | sed 's/ .*//')
1025
1026# Ensure that we don't accidentally insert an entry into an old NEWS block.
1027sc_immutable_NEWS:
1028 @if test -f $(srcdir)/NEWS; then \
1029 test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : || \
1030 { echo '$(ME): you have modified old NEWS' 1>&2; exit 1; }; \
1031 fi
1032
1033# Update the hash stored above. Do this after each release and
1034# for any corrections to old entries.
1035update-NEWS-hash: NEWS
1036 perl -pi -e 's/^(old_NEWS_hash[ \t]+:?=[ \t]+).*/$${1}'"$(NEWS_hash)/" \
1037 $(srcdir)/cfg.mk
1038
1039# Ensure that we use only the standard $(VAR) notation,
1040# not @...@ in Makefile.am, now that we can rely on automake
1041# to emit a definition for each substituted variable.
dd7d0148
LC
1042# However, there is still one case in which @VAR@ use is not just
1043# legitimate, but actually required: when augmenting an automake-defined
1044# variable with a prefix. For example, gettext uses this:
1045# MAKEINFO = env LANG= LC_MESSAGES= LC_ALL= LANGUAGE= @MAKEINFO@
1046# otherwise, makeinfo would put German or French (current locale)
1047# navigation hints in the otherwise-English documentation.
1048#
61cd9dc9
LC
1049# Allow the package to add exceptions via a hook in cfg.mk;
1050# for example, @PRAGMA_SYSTEM_HEADER@ can be permitted by
1051# setting this to ' && !/PRAGMA_SYSTEM_HEADER/'.
1052_makefile_at_at_check_exceptions ?=
1053sc_makefile_at_at_check:
005de2e8
LC
1054 @perl -ne '/\@\w+\@/' \
1055 -e ' && !/(\w+)\s+=.*\@\1\@$$/' \
dd7d0148 1056 -e ''$(_makefile_at_at_check_exceptions) \
c84bdaf6 1057 -e 'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}' \
dd7d0148 1058 $$($(VC_LIST_EXCEPT) | grep -E '(^|/)(Makefile\.am|[^/]+\.mk)$$') \
c84bdaf6
LC
1059 && { echo '$(ME): use $$(...), not @...@' 1>&2; exit 1; } || :
1060
1cd4fffc 1061news-check: NEWS
005de2e8 1062 if sed -n $(news-check-lines-spec)p $< \
9157d901 1063 | grep -E $(news-check-regexp) >/dev/null; then \
c84bdaf6
LC
1064 :; \
1065 else \
1cd4fffc 1066 echo 'NEWS: $$(news-check-regexp) failed to match' 1>&2; \
c84bdaf6
LC
1067 exit 1; \
1068 fi
1069
1070sc_makefile_TAB_only_indentation:
a927b6c1
LC
1071 @prohibit='^ [ ]{8}' \
1072 in_vc_files='akefile|\.mk$$' \
1073 halt='found TAB-8-space indentation' \
1074 $(_sc_search_regexp)
c84bdaf6
LC
1075
1076sc_m4_quote_check:
a927b6c1
LC
1077 @prohibit='(AC_DEFINE(_UNQUOTED)?|AC_DEFUN)\([^[]' \
1078 in_vc_files='(^configure\.ac|\.m4)$$' \
1079 halt='quote the first arg to AC_DEF*' \
1080 $(_sc_search_regexp)
c84bdaf6
LC
1081
1082fix_po_file_diag = \
1083'you have changed the set of files with translatable diagnostics;\n\
1084apply the above patch\n'
1085
1086# Verify that all source files using _() are listed in po/POTFILES.in.
dd7d0148 1087po_file ?= $(srcdir)/po/POTFILES.in
3d458a81 1088generated_files ?= $(srcdir)/lib/*.[ch]
c84bdaf6
LC
1089sc_po_check:
1090 @if test -f $(po_file); then \
1091 grep -E -v '^(#|$$)' $(po_file) \
1092 | grep -v '^src/false\.c$$' | sort > $@-1; \
1093 files=; \
3d458a81 1094 for file in $$($(VC_LIST_EXCEPT)) $(generated_files); do \
c84bdaf6
LC
1095 test -r $$file || continue; \
1096 case $$file in \
1097 *.m4|*.mk) continue ;; \
1098 *.?|*.??) ;; \
1099 *) continue;; \
1100 esac; \
1101 case $$file in \
1102 *.[ch]) \
1103 base=`expr " $$file" : ' \(.*\)\..'`; \
1104 { test -f $$base.l || test -f $$base.y; } && continue;; \
1105 esac; \
1106 files="$$files $$file"; \
1107 done; \
1108 grep -E -l '\b(N?_|gettext *)\([^)"]*("|$$)' $$files \
dd7d0148 1109 | sed 's|^$(_dot_escaped_srcdir)/||' | sort -u > $@-2; \
c84bdaf6
LC
1110 diff -u -L $(po_file) -L $(po_file) $@-1 $@-2 \
1111 || { printf '$(ME): '$(fix_po_file_diag) 1>&2; exit 1; }; \
1112 rm -f $@-1 $@-2; \
1113 fi
1114
1115# Sometimes it is useful to change the PATH environment variable
1116# in Makefiles. When doing so, it's better not to use the Unix-centric
f0007cad 1117# path separator of ':', but rather the automake-provided '$(PATH_SEPARATOR)'.
005de2e8 1118msg = '$(ME): Do not use ":" above; use $$(PATH_SEPARATOR) instead'
c84bdaf6 1119sc_makefile_path_separator_check:
a927b6c1
LC
1120 @prohibit='PATH[=].*:' \
1121 in_vc_files='akefile|\.mk$$' \
1122 halt=$(msg) \
1123 $(_sc_search_regexp)
c84bdaf6 1124
f0007cad 1125# Check that 'make alpha' will not fail at the end of the process,
35428fb6
LC
1126# i.e., when pkg-M.N.tar.xz already exists (either in "." or in ../release)
1127# and is read-only.
c84bdaf6 1128writable-files:
35428fb6
LC
1129 if test -d $(release_archive_dir); then \
1130 for file in $(DIST_ARCHIVES); do \
1131 for p in ./ $(release_archive_dir)/; do \
1132 test -e $$p$$file || continue; \
1133 test -w $$p$$file \
1134 || { echo ERROR: $$p$$file is not writable; fail=1; }; \
1135 done; \
c84bdaf6
LC
1136 done; \
1137 test "$$fail" && exit 1 || : ; \
35428fb6 1138 else :; \
c84bdaf6
LC
1139 fi
1140
2e65b52f 1141v_etc_file = $(gnulib_dir)/lib/version-etc.c
c84bdaf6
LC
1142sample-test = tests/sample-test
1143texi = doc/$(PACKAGE).texi
1144# Make sure that the copyright date in $(v_etc_file) is up to date.
1145# Do the same for the $(sample-test) and the main doc/.texi file.
1146sc_copyright_check:
a927b6c1
LC
1147 @require='enum { COPYRIGHT_YEAR = '$$(date +%Y)' };' \
1148 in_files=$(v_etc_file) \
1149 halt='out of date copyright in $(v_etc_file); update it' \
1150 $(_sc_search_regexp)
1151 @require='# Copyright \(C\) '$$(date +%Y)' Free' \
1152 in_vc_files=$(sample-test) \
1153 halt='out of date copyright in $(sample-test); update it' \
1154 $(_sc_search_regexp)
1155 @require='Copyright @copyright\{\} .*'$$(date +%Y)' Free' \
1156 in_vc_files=$(texi) \
1157 halt='out of date copyright in $(texi); update it' \
1158 $(_sc_search_regexp)
1159
1160# If tests/help-version exists and seems to be new enough, assume that its
1161# use of init.sh and path_prepend_ is correct, and ensure that every other
1162# use of init.sh is identical.
1163# This is useful because help-version cross-checks prog --version
1164# with $(VERSION), which verifies that its path_prepend_ invocation
1165# sets PATH correctly. This is an inexpensive way to ensure that
1166# the other init.sh-using tests also get it right.
1167_hv_file ?= $(srcdir)/tests/help-version
1168_hv_regex_weak ?= ^ *\. .*/init\.sh"
231c0e0e 1169# Fix syntax-highlighters "
a927b6c1
LC
1170_hv_regex_strong ?= ^ *\. "\$${srcdir=\.}/init\.sh"
1171sc_cross_check_PATH_usage_in_tests:
1172 @if test -f $(_hv_file); then \
1173 grep -l 'VERSION mismatch' $(_hv_file) >/dev/null \
1174 || { echo "$@: skipped: no such file: $(_hv_file)" 1>&2; \
1175 exit 0; }; \
1176 grep -lE '$(_hv_regex_strong)' $(_hv_file) >/dev/null \
1177 || { echo "$@: $(_hv_file) lacks conforming use of init.sh" 1>&2; \
1178 exit 1; }; \
1179 good=$$(grep -E '$(_hv_regex_strong)' $(_hv_file)); \
1180 grep -LFx "$$good" \
1181 $$(grep -lE '$(_hv_regex_weak)' $$($(VC_LIST_EXCEPT))) \
1182 | grep . && \
1183 { echo "$(ME): the above files use path_prepend_ inconsistently" \
1184 1>&2; exit 1; } || :; \
c84bdaf6
LC
1185 fi
1186
7f1ea859
LC
1187# BRE regex of file contents to identify a test script.
1188_test_script_regex ?= \<init\.sh\>
1189
1190# In tests, use "compare expected actual", not the reverse.
1191sc_prohibit_reversed_compare_failure:
1192 @prohibit='\<compare [^ ]+ ([^ ]*exp|/dev/null)' \
1193 containing='$(_test_script_regex)' \
1194 halt='reversed compare arguments' \
1195 $(_sc_search_regexp)
1196
61cd9dc9
LC
1197# #if HAVE_... will evaluate to false for any non numeric string.
1198# That would be flagged by using -Wundef, however gnulib currently
1199# tests many undefined macros, and so we can't enable that option.
1200# So at least preclude common boolean strings as macro values.
1201sc_Wundef_boolean:
a927b6c1
LC
1202 @prohibit='^#define.*(yes|no|true|false)$$' \
1203 in_files='$(CONFIG_INCLUDE)' \
1204 halt='Use 0 or 1 for macro values' \
1205 $(_sc_search_regexp)
61cd9dc9 1206
231c0e0e
LC
1207# Even if you use pathmax.h to guarantee that PATH_MAX is defined, it might
1208# not be constant, or might overflow a stack. In general, use PATH_MAX as
1209# a limit, not an array or alloca size.
1210sc_prohibit_path_max_allocation:
1211 @prohibit='(\balloca *\([^)]*|\[[^]]*)PATH_MAX' \
1212 halt='Avoid stack allocations of size PATH_MAX' \
1213 $(_sc_search_regexp)
1214
61cd9dc9 1215sc_vulnerable_makefile_CVE-2009-4029:
a927b6c1
LC
1216 @prohibit='perm -777 -exec chmod a\+rwx|chmod 777 \$$\(distdir\)' \
1217 in_files=$$(find $(srcdir) -name Makefile.in) \
0f00f2c3
LC
1218 halt=$$(printf '%s\n' \
1219 'the above files are vulnerable; beware of running' \
1220 ' "make dist*" rules, and upgrade to fixed automake' \
1221 ' see http://bugzilla.redhat.com/542609 for details') \
a927b6c1 1222 $(_sc_search_regexp)
61cd9dc9 1223
c84bdaf6
LC
1224vc-diff-check:
1225 (unset CDPATH; cd $(srcdir) && $(VC) diff) > vc-diffs || :
1226 if test -s vc-diffs; then \
1227 cat vc-diffs; \
1228 echo "Some files are locally modified:" 1>&2; \
1229 exit 1; \
1230 else \
1231 rm vc-diffs; \
1232 fi
1233
c84bdaf6
LC
1234rel-files = $(DIST_ARCHIVES)
1235
1236gnulib_dir ?= $(srcdir)/gnulib
1237gnulib-version = $$(cd $(gnulib_dir) && git describe)
1238bootstrap-tools ?= autoconf,automake,gnulib
1239
61cd9dc9
LC
1240# If it's not already specified, derive the GPG key ID from
1241# the signed tag we've just applied to mark this release.
1242gpg_key_ID ?= \
7f1ea859
LC
1243 $$(git cat-file tag v$(VERSION) \
1244 | gpgv --status-fd 1 --keyring /dev/null - - 2>/dev/null \
005de2e8 1245 | awk '/^\[GNUPG:\] ERRSIG / {print $$3; exit}')
61cd9dc9 1246
a927b6c1 1247translation_project_ ?= coordinator@translationproject.org
3d458a81
AW
1248
1249# Make info-gnu the default only for a stable release.
1250ifeq ($(RELEASE_TYPE),stable)
1251 announcement_Cc_ ?= $(translation_project_), $(PACKAGE_BUGREPORT)
1252 announcement_mail_headers_ ?= \
1253 To: info-gnu@gnu.org \
1254 Cc: $(announcement_Cc_) \
1255 Mail-Followup-To: $(PACKAGE_BUGREPORT)
1256else
1257 announcement_Cc_ ?= $(translation_project_)
1258 announcement_mail_headers_ ?= \
1259 To: $(PACKAGE_BUGREPORT) \
1260 Cc: $(announcement_Cc_)
1261endif
a927b6c1 1262
c84bdaf6 1263announcement: NEWS ChangeLog $(rel-files)
7f1ea859 1264 @$(srcdir)/$(_build-aux)/announce-gen \
a927b6c1 1265 --mail-headers='$(announcement_mail_headers_)' \
c84bdaf6
LC
1266 --release-type=$(RELEASE_TYPE) \
1267 --package=$(PACKAGE) \
1268 --prev=$(PREV_VERSION) \
1269 --curr=$(VERSION) \
1270 --gpg-key-id=$(gpg_key_ID) \
005de2e8 1271 --srcdir=$(srcdir) \
61cd9dc9 1272 --news=$(srcdir)/NEWS \
c84bdaf6 1273 --bootstrap-tools=$(bootstrap-tools) \
005de2e8
LC
1274 $$(case ,$(bootstrap-tools), in (*,gnulib,*) \
1275 echo --gnulib-version=$(gnulib-version);; esac) \
c84bdaf6
LC
1276 --no-print-checksums \
1277 $(addprefix --url-dir=, $(url_dir_list))
1278
1279## ---------------- ##
1280## Updating files. ##
1281## ---------------- ##
1282
1283ftp-gnu = ftp://ftp.gnu.org/gnu
1284www-gnu = http://www.gnu.org
1285
dde9c5a4 1286upload_dest_dir_ ?= $(PACKAGE)
c84bdaf6
LC
1287emit_upload_commands:
1288 @echo =====================================
1289 @echo =====================================
7f1ea859 1290 @echo "$(srcdir)/$(_build-aux)/gnupload $(GNUPLOADFLAGS) \\"
dde9c5a4 1291 @echo " --to $(gnu_rel_host):$(upload_dest_dir_) \\"
c84bdaf6 1292 @echo " $(rel-files)"
61cd9dc9 1293 @echo '# send the ~/announce-$(my_distdir) e-mail'
c84bdaf6
LC
1294 @echo =====================================
1295 @echo =====================================
1296
c84bdaf6 1297define emit-commit-log
35428fb6
LC
1298 printf '%s\n' 'maint: post-release administrivia' '' \
1299 '* NEWS: Add header line for next release.' \
1300 '* .prev-version: Record previous version.' \
c84bdaf6
LC
1301 '* cfg.mk (old_NEWS_hash): Auto-update.'
1302endef
1303
1304.PHONY: no-submodule-changes
1305no-submodule-changes:
1306 if test -d $(srcdir)/.git; then \
1307 diff=$$(cd $(srcdir) && git submodule -q foreach \
1308 git diff-index --name-only HEAD) \
1309 || exit 1; \
1310 case $$diff in '') ;; \
1311 *) echo '$(ME): submodule files are locally modified:'; \
1312 echo "$$diff"; exit 1;; esac; \
1313 else \
1314 : ; \
1315 fi
1316
49114fd4
LC
1317submodule-checks ?= no-submodule-changes public-submodule-commit
1318
1319# Ensure that each sub-module commit we're using is public.
1320# Without this, it is too easy to tag and release code that
1321# cannot be built from a fresh clone.
1322.PHONY: public-submodule-commit
1323public-submodule-commit:
1324 $(AM_V_GEN)if test -d $(srcdir)/.git; then \
1325 cd $(srcdir) && \
1326 git submodule --quiet foreach test '$$(git rev-parse $$sha1)' \
1327 = '$$(git merge-base origin $$sha1)' \
1328 || { echo '$(ME): found non-public submodule commit' >&2; \
1329 exit 1; }; \
1330 else \
1331 : ; \
1332 fi
1333# This rule has a high enough utility/cost ratio that it should be a
1334# dependent of "check" by default. However, some of us do occasionally
1335# commit a temporary change that deliberately points to a non-public
1336# submodule commit, and want to be able to use rules like "make check".
1337# In that case, run e.g., "make check gl_public_submodule_commit="
1338# to disable this test.
1339gl_public_submodule_commit ?= public-submodule-commit
1340check: $(gl_public_submodule_commit)
1341
c84bdaf6
LC
1342.PHONY: alpha beta stable
1343ALL_RECURSIVE_TARGETS += alpha beta stable
49114fd4 1344alpha beta stable: $(local-check) writable-files $(submodule-checks)
c84bdaf6
LC
1345 test $@ = stable \
1346 && { echo $(VERSION) | grep -E '^[0-9]+(\.[0-9]+)+$$' \
1347 || { echo "invalid version string: $(VERSION)" 1>&2; exit 1;};}\
1348 || :
1349 $(MAKE) vc-diff-check
1cd4fffc 1350 $(MAKE) news-check
c84bdaf6 1351 $(MAKE) distcheck
005de2e8 1352 $(MAKE) dist
1cd4fffc
LC
1353 $(MAKE) $(release-prep-hook) RELEASE_TYPE=$@
1354 $(MAKE) -s emit_upload_commands RELEASE_TYPE=$@
1355
1356# Override this in cfg.mk if you follow different procedures.
1357release-prep-hook ?= release-prep
1358
0f00f2c3 1359gl_noteworthy_news_ = * Noteworthy changes in release ?.? (????-??-??) [?]
1cd4fffc
LC
1360.PHONY: release-prep
1361release-prep:
1362 case $$RELEASE_TYPE in alpha|beta|stable) ;; \
1363 *) echo "invalid RELEASE_TYPE: $$RELEASE_TYPE" 1>&2; exit 1;; esac
3d458a81 1364 $(MAKE) --no-print-directory -s announcement > ~/announce-$(my_distdir)
c84bdaf6
LC
1365 if test -d $(release_archive_dir); then \
1366 ln $(rel-files) $(release_archive_dir); \
1367 chmod a-w $(rel-files); \
1368 fi
c84bdaf6
LC
1369 echo $(VERSION) > $(prev_version_file)
1370 $(MAKE) update-NEWS-hash
005de2e8 1371 perl -pi -e '$$. == 3 and print "$(gl_noteworthy_news_)\n\n\n"' $(srcdir)/NEWS
c84bdaf6
LC
1372 $(emit-commit-log) > .ci-msg
1373 $(VC) commit -F .ci-msg -a
61cd9dc9 1374 rm .ci-msg
c84bdaf6 1375
a927b6c1
LC
1376# Override this with e.g., -s $(srcdir)/some_other_name.texi
1377# if the default $(PACKAGE)-derived name doesn't apply.
1378gendocs_options_ ?=
1379
c84bdaf6
LC
1380.PHONY: web-manual
1381web-manual:
1382 @test -z "$(manual_title)" \
1383 && { echo define manual_title in cfg.mk 1>&2; exit 1; } || :
1384 @cd '$(srcdir)/doc'; \
7f1ea859 1385 $(SHELL) ../$(_build-aux)/gendocs.sh $(gendocs_options_) \
a927b6c1 1386 -o '$(abs_builddir)/doc/manual' \
c84bdaf6
LC
1387 --email $(PACKAGE_BUGREPORT) $(PACKAGE) \
1388 "$(PACKAGE_NAME) - $(manual_title)"
1389 @echo " *** Upload the doc/manual directory to web-cvs."
1390
1391# Code Coverage
1392
1393init-coverage:
1394 $(MAKE) $(AM_MAKEFLAGS) clean
1395 lcov --directory . --zerocounters
1396
1397COVERAGE_CCOPTS ?= "-g --coverage"
1398COVERAGE_OUT ?= doc/coverage
1399
1400build-coverage:
1401 $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS)
1402 $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS) check
1403 mkdir -p $(COVERAGE_OUT)
1404 lcov --directory . --output-file $(COVERAGE_OUT)/$(PACKAGE).info \
1405 --capture
1406
1407gen-coverage:
1408 genhtml --output-directory $(COVERAGE_OUT) \
1409 $(COVERAGE_OUT)/$(PACKAGE).info \
1410 --highlight --frames --legend \
1411 --title "$(PACKAGE_NAME)"
1412
1413coverage: init-coverage build-coverage gen-coverage
1414
1415# Update gettext files.
1416PACKAGE ?= $(shell basename $(PWD))
1417PO_DOMAIN ?= $(PACKAGE)
1418POURL = http://translationproject.org/latest/$(PO_DOMAIN)/
1419PODIR ?= po
1420refresh-po:
1421 rm -f $(PODIR)/*.po && \
1422 echo "$(ME): getting translations into po (please ignore the robots.txt ERROR 404)..." && \
1423 wget --no-verbose --directory-prefix $(PODIR) --no-directories --recursive --level 1 --accept .po --accept .po.1 $(POURL) && \
1424 echo 'en@boldquot' > $(PODIR)/LINGUAS && \
1425 echo 'en@quot' >> $(PODIR)/LINGUAS && \
005de2e8 1426 ls $(PODIR)/*.po | sed 's/\.po//;s,$(PODIR)/,,' | sort >> $(PODIR)/LINGUAS
c84bdaf6 1427
a927b6c1 1428 # Running indent once is not idempotent, but running it twice is.
c84bdaf6
LC
1429INDENT_SOURCES ?= $(C_SOURCES)
1430.PHONY: indent
1431indent:
1432 indent $(INDENT_SOURCES)
a927b6c1 1433 indent $(INDENT_SOURCES)
c84bdaf6
LC
1434
1435# If you want to set UPDATE_COPYRIGHT_* environment variables,
1436# put the assignments in this variable.
1437update-copyright-env ?=
1438
1439# Run this rule once per year (usually early in January)
1440# to update all FSF copyright year lists in your project.
1441# If you have an additional project-specific rule,
1442# add it in cfg.mk along with a line 'update-copyright: prereq'.
1443# By default, exclude all variants of COPYING; you can also
1444# add exemptions (such as ChangeLog..* for rotated change logs)
1445# in the file .x-update-copyright.
1446.PHONY: update-copyright
1447update-copyright:
1448 grep -l -w Copyright \
1449 $$(export VC_LIST_EXCEPT_DEFAULT=COPYING && $(VC_LIST_EXCEPT)) \
7f1ea859 1450 | $(update-copyright-env) xargs $(srcdir)/$(_build-aux)/$@
3d458a81
AW
1451
1452# This tight_scope test is skipped with a warning if $(_gl_TS_headers) is not
1453# overridden and $(_gl_TS_dir)/Makefile.am does not mention noinst_HEADERS.
1454
1455# NOTE: to override any _gl_TS_* default value, you must
1456# define the variable(s) using "export" in cfg.mk.
1457_gl_TS_dir ?= src
1458
1459ALL_RECURSIVE_TARGETS += sc_tight_scope
1460sc_tight_scope: tight-scope.mk
35428fb6
LC
1461 @fail=0; \
1462 if ! grep '^ *export _gl_TS_headers *=' $(srcdir)/cfg.mk \
3d458a81
AW
1463 > /dev/null \
1464 && ! grep -w noinst_HEADERS $(srcdir)/$(_gl_TS_dir)/Makefile.am \
1465 > /dev/null 2>&1; then \
1466 echo '$(ME): skipping $@'; \
1467 else \
1468 $(MAKE) -s -C $(_gl_TS_dir) \
1469 -f Makefile \
1470 -f $(abs_top_srcdir)/cfg.mk \
1471 -f $(abs_top_builddir)/$< \
1472 _gl_tight_scope \
1473 || fail=1; \
35428fb6
LC
1474 fi; \
1475 rm -f $<; \
1476 exit $$fail
3d458a81
AW
1477
1478tight-scope.mk: $(ME)
1479 @rm -f $@ $@-t
7f1ea859 1480 @perl -ne '/^# TS-start/.../^# TS-end/ and print' $(srcdir)/$(ME) > $@-t
3d458a81
AW
1481 @chmod a=r $@-t && mv $@-t $@
1482
1483ifeq (a,b)
1484# TS-start
1485
1486# Most functions should have static scope.
f0007cad
LC
1487# Any that don't must be marked with 'extern', but 'main'
1488# and 'usage' are exceptions: they're always extern, but
1489# do not need to be marked. Symbols matching '__.*' are
3d458a81
AW
1490# reserved by the compiler, so are automatically excluded below.
1491_gl_TS_unmarked_extern_functions ?= main usage
35428fb6 1492_gl_TS_function_match ?= /^(?:$(_gl_TS_extern)) +.*?(\S+) *\(/
3d458a81
AW
1493
1494# If your project uses a macro like "XTERN", then put
1495# the following in cfg.mk to override this default:
1496# export _gl_TS_extern = extern|XTERN
1497_gl_TS_extern ?= extern
1498
f0007cad 1499# The second nm|grep checks for file-scope variables with 'extern' scope.
3d458a81 1500# Without gnulib's progname module, you might put program_name here.
f0007cad 1501# Symbols matching '__.*' are reserved by the compiler,
3d458a81
AW
1502# so are automatically excluded below.
1503_gl_TS_unmarked_extern_vars ?=
1504
1505# NOTE: the _match variables are perl expressions -- not mere regular
1506# expressions -- so that you can extend them to match other patterns
1507# and easily extract matched variable names.
1508# For example, if your project declares some global variables via
1509# a macro like this: GLOBAL(type, var_name, initializer), then you
1510# can override this definition to automatically extract those names:
1511# export _gl_TS_var_match = \
1512# /^(?:$(_gl_TS_extern)) .*?\**(\w+)(\[.*?\])?;/ || /\bGLOBAL\(.*?,\s*(.*?),/
1513_gl_TS_var_match ?= /^(?:$(_gl_TS_extern)) .*?(\w+)(\[.*?\])?;/
1514
1515# The names of object files in (or relative to) $(_gl_TS_dir).
1516_gl_TS_obj_files ?= *.$(OBJEXT)
1517
1518# Files in which to search for the one-line style extern declarations.
1519# $(_gl_TS_dir)-relative.
1520_gl_TS_headers ?= $(noinst_HEADERS)
1521
1522.PHONY: _gl_tight_scope
1523_gl_tight_scope: $(bin_PROGRAMS)
1524 t=exceptions-$$$$; \
1525 trap 's=$$?; rm -f $$t; exit $$s' 0; \
1526 for sig in 1 2 3 13 15; do \
1527 eval "trap 'v=`expr $$sig + 128`; (exit $$v); exit $$v' $$sig"; \
1528 done; \
1529 src=`for f in $(SOURCES); do \
1530 test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`; \
1531 hdr=`for f in $(_gl_TS_headers); do \
1532 test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`; \
1533 ( printf '^%s$$\n' '__.*' $(_gl_TS_unmarked_extern_functions); \
1534 grep -h -A1 '^extern .*[^;]$$' $$src \
1535 | grep -vE '^(extern |--)' | sed 's/ .*//'; \
1536 perl -lne \
1537 '$(_gl_TS_function_match) and print "^$$1\$$"' $$hdr; \
1538 ) | sort -u > $$t; \
1539 nm -e $(_gl_TS_obj_files) | sed -n 's/.* T //p'|grep -Ev -f $$t \
1540 && { echo the above functions should have static scope >&2; \
1541 exit 1; } || : ; \
1542 ( printf '^%s$$\n' '__.*' $(_gl_TS_unmarked_extern_vars); \
1543 perl -lne '$(_gl_TS_var_match) and print "^$$1\$$"' $$hdr *.h \
1544 ) | sort -u > $$t; \
1545 nm -e $(_gl_TS_obj_files) | sed -n 's/.* [BCDGRS] //p' \
1546 | sort -u | grep -Ev -f $$t \
1547 && { echo the above variables should have static scope >&2; \
1548 exit 1; } || :
1549# TS-end
1550endif